//
//  MyView.m
//  EX51vdP
//
//  Created by 川上 博 on 10/04/22.
//  Copyright 2010 徳島大学. All rights reserved.
//

#import "MyView.h"

NSTimer *repeatTimer;
NSBezierPath *oval;

double x[2], x1[2], xm[2], ym[2], u[2], alpha[2], p[2]; 

void func(double x[], double f[], double t)
{
	f[0] = x[1];
	f[1] = 0.7*(1.0-x[0]*x[0])*x[1]-x[0];
}

void runge(int n, double h, double x[], double t)
{
	double k1[n],k2[n],k3[n],k4[n],xtemp[n];
	int i;
	
	func(x,k1,t);
	for (i=0; i<n; i++) xtemp[i]=x[i]+k1[i]/2.0*h;
	t+=h/2.0;
	func(xtemp,k2,t);
	for (i=0; i<n; i++) xtemp[i]=x[i]+k2[i]/2.0*h;
	func(xtemp,k3,t);
	for (i=0; i<n; i++) xtemp[i]=x[i]+k3[i]*h;
	t+=h/2.0;
	func(xtemp,k4,t);
	for (i=0; i<n; i++) x[i]+=(k1[i]+2.0*(k2[i]+k3[i])+k4[i])/6.0*h;
}

@implementation MyView

- (id)initWithFrame:(NSRect)frameRect
{
	if ((self = [super initWithFrame:frameRect]) != nil) {
		xm[0]=-3.0; xm[1]=3.0; ym[0]=-3.0; ym[1]=3.0;
		x[0]=0.1; x[1]=0.0;
		p[0]=0.5; p[1]=0.8;
		
        repeatTimer = [[NSTimer scheduledTimerWithTimeInterval:0.001
														target:self
													  selector:@selector(drawByTimer:)
													  userInfo:nil
													   repeats:YES
						] retain];
	}
	return self;
}

- (BOOL)acceptsFirstResponder
{
	return YES;
}

- (void)dealloc
{
    [repeatTimer release];
    [super dealloc];
}

- (void)drawMotion:(NSRect )rect
{
	double a[2],y[2];
	
	alpha[0] = rect.size.width/(xm[1]-xm[0]);
	alpha[1] = rect.size.height/(ym[1]-ym[0]);
	y[0]=x[0]; y[1]=x[1];
	a[0]=alpha[0]*(y[0]-xm[0]);
	a[1]=alpha[1]*(y[1]-ym[0]);
    
	runge(2,0.05,x,0.0);
    
	u[0]=alpha[0]*(x[0]-xm[0]);
	u[1]=alpha[1]*(x[1]-ym[0]);
	
	[[NSColor blueColor] set];
    oval = [NSBezierPath bezierPath];
	[oval moveToPoint:NSMakePoint(a[0],a[1])];
	[oval lineToPoint:NSMakePoint(u[0],u[1])];
    [oval stroke];
}

- (void)drawRect:(NSRect)rect
{
	[[NSColor whiteColor] set];
	NSRectFill(rect);
}

- (void)drawByTimer:(id)timer
{
    NSRect visRect;
	
    [self lockFocus];
    visRect = [self visibleRect];
    [self drawMotion:visRect];
    [self unlockFocus];
	
    [[self window] flushWindow];
}

- (void) mouseDown:(NSEvent *)theEvent
{
	NSPoint temp;
	NSPoint loc=[theEvent locationInWindow];
	
	loc.x -= [self frame].origin.x;
	loc.y -= [self frame].origin.y;
	
	x[0]=loc.x/alpha[0] + xm[0];
	x[1]=loc.y/alpha[1] + ym[0];	
	
	temp=[self convertPoint:loc toView:nil];
    [[NSColor redColor] set];
	[[NSBezierPath bezierPathWithOvalInRect:NSMakeRect(temp.x-4, temp.y-4, 8, 8)] fill];
	
}

- (void)keyDown:(NSEvent *)theEvent
{
	switch([[theEvent characters] characterAtIndex:0]){
		case 'q':case 'Q':case '\033':
			exit(0);
			break;
		case 'e':case 'E':
			[self setNeedsDisplay:YES];
			break;
		default:
			break;
	}
}

@end
